
// Generation of Quartus project

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>

// To create and scan directories
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include "../../augh/auto/auto.h"
#include "../../augh/auto/command.h"
#include "../../augh/plugins/plugins.h"
#include "../../augh/netlist/netlist.h"
#include "../../augh/netlist/netlist_access.h"

#include "altera_techno.h"
#include "altera_quartus.h"



typedef struct quartus_proj_conf_t {
	char* dirname;
	char* topname;
	char* target_fpga;
	chain_list* list_dir_src;
	chain_list* list_file_src;
} quartus_proj_conf_t;

// Generated file names
static char* filename_tcl  = "project.tcl";
static char* filename_sdc  = "project.sdc";
static char* filename_make = "Makefile";

// FIXME Missing Makefile rules for postsynth and postpar simulations
//   and for programming of the board

static int Quartus_Gen_Project_conf(implem_t* Implem, quartus_proj_conf_t* conf) {

	printf("Generating project files for Altera Quartus...\n");

	// Define the part name
	char* partname = conf->target_fpga;
	dbgprintf("Partname: %s\n", partname);

	altera_techdata_t* techdata = Implem->synth_target->techno_data;
	board_fpga_t* board_fpga = Implem->synth_target->board_fpga;

	char* path_comeback = ".";
	if(strcmp(conf->dirname, ".")!=0) {
		mkdir(conf->dirname,  S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
		path_comeback = "..";
	}

	char pathbuf[strlen(conf->dirname) + 30];

	// The main TCL file
	dbgprintf("Generating TCL file...\n");

	sprintf(pathbuf, "%s/%s", conf->dirname, filename_tcl);
	FILE* F = fopen(pathbuf, "wb");
	if(F==NULL) {
		printf("ERROR: could not open the file %s.\n", pathbuf);
		return -1;
	}

	// The main declarations
	fprintfm(F,
		"# This TCL script was generated by AUGH\n"
		"\n"
		"# For documentation, see Altera manual:\n"
		"#   Quartus II Scripting Reference Manual\n"
		"\n"
		"project_new project_%s -overwrite\n", conf->topname,
		"\n"
		"set_global_assignment -name FAMILY ARRIAV\n"
		"set_global_assignment -name DEVICE %s\n", partname,
		"set_global_assignment -name TOP_LEVEL_ENTITY %s\n", conf->topname,
		"set_global_assignment -name SDC_FILE %s\n", filename_sdc,
		"\n",
		NULL
	);

	dbgprintf("Generating design sources...\n");

	{  // These brackets are only here to fold the code :-)

		fprintf(F,
			"\n"
			"# Setup design sources\n"
			"\n"
		);

		// This part generates a list of vhdl files to read

		foreach(conf->list_dir_src, scanSrc) {
			char* dirname_vhd = scanSrc->DATA;
			DIR *dp = opendir(dirname_vhd);
			if(dp==NULL) {
				printf("WARNING: Can't scan the folder '%s' for VHDL files. Skipping.\n", dirname_vhd);
				continue;
			}
			do {
				struct dirent *ep = readdir(dp);
				if(ep==NULL) break;
				// Get the file extension
				char* beg_ext = NULL;
				char* scan_name = ep->d_name;
				while(*scan_name!=0) {
					if(*scan_name=='.') beg_ext = scan_name+1;
					scan_name++;
				}
				// Check the file extension
				if(beg_ext==NULL) continue;
				if(strcasecmp(beg_ext, "vhd")!=0) continue;
				fprintf(F, "set_global_assignment -name VHDL_FILE \"%s/%s/%s\"\n", path_comeback, dirname_vhd, ep->d_name);
			}while(1);

			closedir(dp);
		}  // Scan the list of directories

		// Add the VHDL files given directly
		foreach(conf->list_file_src, scanSrc) {
			char* file_name = scanSrc->DATA;
			fprintf(F, "set_global_assignment -name VHDL_FILE \"%s/%s\"\n", path_comeback, file_name);
		}

		fputc('\n', F);

	}

	dbgprintf("Generating I/O constraints...\n");
	bool constraints_incomplete = false;

	{  // These brackets are only here to fold the code :-)

		fprintf(F,
			"\n"
			"# Setup I/O constraints\n"
			"\n"
		);

		if(board_fpga!=NULL) {
			fprintf(F, "# Constraints for the board '%s', FPGA '%s'\n", board_fpga->board->name, board_fpga->name);
			if(board_fpga->board->description!=NULL) {
				fprintf(F, "#   Board description: %s\n", board_fpga->board->description);
			}
			if(board_fpga->description!=NULL) {
				fprintf(F, "#   Chip description: %s\n", board_fpga->description);
			}
			if(board_fpga->model!=NULL) {
				fprintf(F, "# Targeted FPGA: %s\n", board_fpga->model->name);
				if(board_fpga->model->description!=NULL) {
					fprintf(F, "#   Description: %s\n", board_fpga->model->description);
				}
			}
		}
		else {
			fprintf(F, "# User-defined target: chip '%s'\n", conf->target_fpga);
		}
		fputc('\n', F);

		// A utility function to generate constraints for one port
		void gen_rule_port_tcl_single(netlist_port_t* port, chain_list* port_pin_desc) {
			// Print descriptive comment
			fprintf(F, "# Port '%s'", port->name);
			if(port->access==NULL) {
				fprintf(F, " (not part of an access structure)\n");
			}
			else {
				fprintf(F, " of access '%s' model '%s'\n", port->access->name, port->access->model->name);
			}
			// Print attributes
			unsigned pin_idx = 0;
			foreach(port_pin_desc, scanPin) {
				chain_list* attributes = scanPin->DATA;
				foreach(attributes, scanAttr) {
					char* strattr = scanAttr->DATA;
					if(strncasecmp(strattr, "pin", 3)==0) {
						char* param = SplitString_trim_beg(strattr + 3);
						fprintf(F, "set_location_assignment PIN_%s", param);
					}
					else if(strncasecmp(strattr, "io_standard", 11)==0) {
						char* param = SplitString_trim_beg(strattr + 11);
						fprintf(F, "set_instance_assignment -name IO_STANDARD \"%s\"", param);
					}
					else {
						printf("Warning: Unhandled constraint: %s", strattr);
						continue;
					}
					fprintf(F, " -to %s", port->name);
					if(port->width > 1) fprintf(F, "[%u]", pin_idx);
					fprintf(F, "\n");
				}
				pin_idx ++;
			}
		}

		avl_pp_foreach(&Implem->netlist.top->ports, scan) {
			netlist_port_t* port = scan->data;
			chain_list* port_pin_desc = NULL;

			char* no_attr_reason = NULL;

			// Try user-defined port attributes
			avl_pp_find_data(&Implem->synth_target->port2pin, port, (void**)&port_pin_desc);
			if(port_pin_desc!=NULL) {

				if(Implem->synth_target->board_fpga!=NULL) {
					fprintf(F, "# Note: Pin attributes for this port are user-defined.\n");
				}

				// Write the rules for this port
				gen_rule_port_tcl_single(port, port_pin_desc);
				fputc('\n', F);

				continue;
			}

			// Try board-defined port attributes
			if(Implem->synth_target->board_fpga!=NULL) {

				// Get the standard identifier of the port, inside its access structure
				if(port->access==NULL) {
					no_attr_reason = "Not part of an access structure";
					goto NOATTR;
				}

				// Get the corresponding access from the board_fpga
				netlist_access_t* board_access = NULL;
				avl_pp_find_data(&Implem->synth_target->impacc2boardacc, port->access, (void**)&board_access);
				if(board_access==NULL) {
					no_attr_reason = "No corresponding board access structure";
					goto NOATTR;
				}

				// Get the standard name of the port
				char* stdname = Netlist_Access_Port_GetName(port);
				if(stdname==NULL) {
					no_attr_reason = "Can't identify in access structure";
					goto NOATTR;
				}

				// Get the corresponding board port
				netlist_port_t* board_port = Netlist_Access_Name2Port(board_access, stdname);
				if(board_port==NULL) {
					no_attr_reason = "Can't get corresponding board port";
					goto NOATTR;
				}

				// Finally, get the pin attributes
				port_pin_desc = NULL;
				avl_pp_find_data(&Implem->synth_target->board_fpga->port2pin, board_port, (void**)&port_pin_desc);
				if(port_pin_desc==NULL) {
					no_attr_reason = "The board has no attributes";
					goto NOATTR;
				}

				// Write the rules for this port
				gen_rule_port_tcl_single(port, port_pin_desc);
				fputc('\n', F);

				continue;
			}

			// Here there is no attributes

			// Utility function
			void printfnoattr(FILE* locF, char* pref) {
				if(pref!=NULL) fprintf(locF, "%s", pref);
				fprintf(locF, "WARNING: No pin attributes for port '%s'.", port->name);
				if(no_attr_reason!=NULL) fprintf(locF, " Reason: %s.", no_attr_reason);
				fputc('\n', locF);
			}

			NOATTR:

			printfnoattr(stdout, NULL);
			printfnoattr(F, "# ");
			fputc('\n', F);

			constraints_incomplete = true;

		}  // Scan all ports

		if(constraints_incomplete==true) {
			printf("WARNING: Some ports had no pin attributes. The constraints may be incomplete.\n");
		}

	}

	// Generate the rest of the TCL file

	fprintf(F,
		"\n"
		"# Commit assignments\n"
		"export_assignments\n"
		"\n"
		"project_close\n"
		"\n"
		"\n"
	);

	// Close the main TCL file
	fclose(F);

	dbgprintf("Generating SDC file...\n");

	{  // These brackets are only here to fold the code :-)

		sprintf(pathbuf, "%s/%s", conf->dirname, filename_sdc);
		FILE* F = fopen(pathbuf, "wb");
		if(F==NULL) {
			printf("ERROR: could not open the file %s.\n", pathbuf);
			return -1;
		}

		fprintf(F,
			"# This SDC file was generated by AUGH\n"
			"\n"
			"set_time_unit ns\n"
			"\n"
		);

		// Declare the clock
		if(Implem->netlist.port_clock!=NULL) {
			bool clkgen_comment = false;

			// Mode: Force no generation of clock config
			if(techdata->force_gen_clock < 0) {
				char* str = "Warning: No clock is declared because of user override.\n";
				fprintf(F, "# %s", str);
				printf(str);
				// The declaration will be commented
				clkgen_comment = true;
			}

			// Mode: auto
			if(techdata->force_gen_clock == 0) {
				if(Implem->time.max_cycles_per_state > 1) {
					char* str = "Warning: No clock is declared because of multi-cycle states.\n";
					fprintf(F, "# %s", str);
					printf(str);
					// The declaration will be commented
					clkgen_comment = true;
				}
				if(Implem->synth_target->clk_period_ns==0) {
					char* str = "Warning: No clock is declared because no frequency/period is set.\n";
					fprintf(F, "# %s", str);
					printf(str);
					// The declaration will be commented
					clkgen_comment = true;
				}
			}

			// Mode: Force generation of clock config
			if(techdata->force_gen_clock > 0) {
				if(Implem->time.max_cycles_per_state > 1) {
					char* str = "Warning: There are multi-cycle states but a clock is declared because of user override.\n";
					fprintf(F, "# %s", str);
					printf(str);
				}
			}

			// Default values
			double clkgen_freq = 100;  // in MHz
			double clkgen_per = 10;  // in ns

			if(Implem->synth_target->clk_period_ns==0) {
				if(clkgen_comment==false) {
					char buf[1024];
					sprintf(buf, "Warning: No clock period is defined. Setting %g MHz by default.\n", clkgen_freq);
					fprintf(F, "# %s", buf);
					printf(buf);
				}
			}
			else {
				clkgen_freq = Implem->synth_target->clk_freq/1e6;
				clkgen_per = Implem->synth_target->clk_period_ns;
			}

			// Write the clock declaration into the file
			if(clkgen_comment==true) {
				fprintf(F, "# Note: Uncomment to activate the clock declaration\n");
			}
			fprintf(F, "# Declaration of the main clock: frequency = %g MHz, period = %g ns, duty cycle 50%%\n", clkgen_freq, clkgen_per);
			if(clkgen_comment==true) fprintf(F, "#");
			fprintf(F, "create_clock -period %f -waveform { 0 5.0 } -name %s %s\n",
				clkgen_per, Implem->netlist.port_clock->name, Implem->netlist.port_clock->name
			);
			fprintf(F, "\n");

		}  // End generation of clock config

		// Close the SDC file
		fclose(F);

	}

	// The Makefile file for SYNTH and IMPLE, GENBITS
	dbgprintf("Generating Makefile...\n");

	{  // These brackets are only here to fold the code :-)
		sprintf(pathbuf, "%s/%s", conf->dirname, filename_make);
		F = fopen(pathbuf, "wb");
		if(F==NULL) {
			printf("ERROR: could not open the file %s.\n", pathbuf);
			return -1;
		}

		fprintfm(F,
			"\n"
			"#================================================\n"
			"# Synthesis with Altera Quartus II\n"
			"#================================================\n"
			"\n"
			"FILENAME_TCL = %s\n", filename_tcl,
			"PROJNAME = project_%s\n", conf->topname,
			"\n"
			".PHONY: all project map fit asm clean\n"
			"\n"
			"all:\n"
			"	$(MAKE) prj\n"
			"	$(MAKE) map\n"
			"	$(MAKE) fit\n"
			"	$(MAKE) asm\n"
			"\n"
			"prj: $(PROJNAME).qpf\n"
			"asm: $(PROJNAME).sof\n"
			"\n"
			"# Create Quartus Project\n"
			"$(PROJNAME).qsf: $(FILENAME_TCL)\n"
			"$(PROJNAME).qpf: $(FILENAME_TCL)\n"
			"	quartus_sh -t $<\n"
			"\n"
			"# Quartus analysis and synthesis\n"
			"map:\n"
			"	quartus_map $(PROJNAME)\n"
			"\n"
			"# Place and route\n"
			"fit:\n"
			"	quartus_fit $(PROJNAME)\n"
			"\n"
			"# Generate device programming files\n"
			"$(PROJNAME).sof:\n"
			"	quartus_asm $(PROJNAME)\n"
			"\n"
			"clean:\n"
			"	rm -rf db incremental_db *.qpf *.qsf *.pin *.jdi *.sof *.rpt *.summary *pin_model_dump.txt\n"
			"\n",
			NULL
		);

		fprintf(F, "\n");
		fclose(F);
	}

	printf("End of Altera Quartus project generation\n");

	return 0;
}

int Quartus_Gen_Project(implem_t* Implem, char* dirname) {
	altera_techdata_t* techdata = Implem->synth_target->techno_data;

	// Config structure
	quartus_proj_conf_t conf_i;
	quartus_proj_conf_t* conf = &conf_i;
	memset(&conf_i, 0, sizeof(conf_i));

	conf->topname = Implem->netlist.top->name;

	conf->dirname = dirname;
	if(conf->dirname==NULL) conf->dirname = techdata->synth_prj_dir;
	if(conf->dirname==NULL) conf->dirname = QUARTUS_PRJ_DEFAULT;

	// Save the project directory in the techdata, in case it isn't
	techdata->synth_prj_dir = conf->dirname;

	unsigned errors_nb = 0;

	if(Implem->synth_target->model!=NULL) conf->target_fpga = Implem->synth_target->model->name;
	else conf->target_fpga = NULL;  // FIXME

	if(conf->target_fpga==NULL) {
		printf("Error [techno '%s']: No FPGA chip target defined.\n", Implem->synth_target->techno->name);
		errors_nb ++;
	}

	if(errors_nb!=0) return -1;

	conf->list_dir_src = addchain(NULL, Implem->env.vhdl_dir);

	// Actual generation
	int z = Quartus_Gen_Project_conf(Implem, conf);

	// Clean
	freechain(conf->list_dir_src);

	return z;
}


// Function to use as callback in techno_t structure
static int Quartus_Gen_Project_callback(implem_t* Implem) {
	return Quartus_Gen_Project(Implem, NULL);
}

// Launch back-end logic synthesis, place and route
// Return 0 if OK
int Quartus_Launch(implem_t* Implem) {
	altera_techdata_t* techdata = Implem->synth_target->techno_data;

	if(techdata->synth_prj_dir==NULL) {
		printf("Error: The back-end project files are not generated. Can't launch back-end.\n");
		return -1;
	}

	// Build the command-line: make -C <dirname>
	char buf[20 + strlen(techdata->synth_prj_dir)];
	sprintf(buf, "make -C %s", techdata->synth_prj_dir);

	fflush(NULL);

	return system(buf);
}


void Quartus_Techno_SetCB(techno_t* techno) {
	techno->synth_gen_prj = Quartus_Gen_Project_callback;
	techno->synth_launch  = Quartus_Launch;
}


